﻿Type=Class
Version=5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals	
	Private data As Map 'RRCC,object
	Private clwidth As Int
	Private clheight As Int
	Private clrow As Int
	Private clcol As Int
	'
	Public ABMComp As ABMCustomComponent
	Public ownPage As ABMPage
	Public ownID As String	
End Sub
 
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String,row As Int,col As Int,cellwidth As Int,cellheight As Int,gap As Int)
	ownPage=InternalPage
	ownID=ID
	clrow = row
	clcol = col
	clwidth=cellwidth
	clheight=cellheight
	data.Initialize
	'
	InternalPage.AddExtraCSSFile("custom/"&ID&".css")	
	WritetoCSS(ID,row,col,clwidth,clheight,gap)
	'InternalPage.AddExtraJavaScriptFile("custom/"&ID&".js")
	'WritetoJS(ID)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID)
End Sub

public Sub component(id As String) As Object
	If data.Size>0 Then
		Dim n1 As Int
		For n1=0 To data.Size-1
			Dim mp1 As Map=data.GetValueAt(n1)
			If mp1.ContainsKey("obj") Then
				If mp1.Get("id")=id Then
					Return mp1.Get("obj")
				End If
			End If
		Next
	Else
		Return Null
	End If
End Sub

public Sub AddArcherJavaScriptFile(Page As ABMPage)
	Page.AddExtraJavaScriptFile("custom/archer.min.js")
End Sub
' datatype 0:digit_meter1 1:binary1
public Sub AddDataDisplayCard(row As Int,col As Int,id As String,datatype As Int)	
	Dim s1 As String=ownID&jylab.ToHex(row,2)&jylab.ToHex(col,2)
	Dim mp1 As Map
	mp1.Initialize
	mp1.Put("id",id)
	mp1.Put("row",row)
	mp1.Put("col",col)
	If datatype=0 Then		
		Dim obj As ABMDigitMeter1
		mp1.Put("obj",obj.Initialize(s1))
	else if datatype=1 Then
		Dim obj1 As ABMbinary1
		mp1.Put("obj",obj1.Initialize(s1))
	End If
	data.Put(s1,mp1)
End Sub
 
private Sub ABMComp_Build(internalID As String) As String
	Dim n1 As Int
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(CRLF)
	sb.append($"<script Type="text/javascript">"$).append(CRLF)
	sb.Append("    var rootUrl_dm1 = '../archer/digital-meter-1/';").Append(CRLF)
	sb.Append("    var rootUrl_by1 = '../archer/binary-1/';").Append(CRLF)
	sb.Append("    var assetUrl = '../archer/assets/';").Append(CRLF)
	sb.Append("    var graphicUrl_dm1 = rootUrl_dm1 + 'archer.graphic.svg';").Append(CRLF)
	sb.Append("    var configUrl_dm1 = rootUrl_dm1 + 'archer.config.json';").Append(CRLF)
	sb.Append("    var graphicUrl_by1 = rootUrl_by1 + 'archer.graphic.svg';").Append(CRLF)
	sb.Append("    var configUrl_by1 = rootUrl_by1 + 'archer.config.json';").Append(CRLF)
	If data.Size>0 Then
		For n1=0 To data.Size-1
			Dim s1 As String=data.GetKeyAt(n1)
			sb.Append($"    var cont${s1};"$).Append(CRLF)
			sb.Append($"    var grap${s1};"$).Append(CRLF)
		Next	
	End If
	sb.Append("</script>").Append(CRLF)
	If data.Size>0 Then
		For n1=0 To data.Size-1
			Dim s1 As String=data.GetKeyAt(n1)			
			sb.Append($"<div id="${s1}"></div>"$).Append(CRLF)
		Next
	End If
	Return sb.ToString
End Sub
 
' Is useful to run some initalisation script.
private Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	If data.size>0 Then
		Dim sb As StringBuilder
		sb.Initialize
		Dim n1 As Int		
		For n1=0 To data.size-1
			Dim s1 As String=data.GetKeyAt(n1)
			Dim mp1 As Map=data.GetValueAt(n1)			
			Dim obj As Object = mp1.Get("obj")
			sb.Append($"cont${s1} = document.getElementById('${s1}');"$).append(CRLF)
			sb.Append($"grap${s1} = archer.create(cont${s1});"$).Append(CRLF)
			sb.Append($"grap${s1}.document.setAssetRoot(assetUrl);"$).Append(CRLF)
			If obj Is ABMDigitMeter1 Then
				sb.Append($"grap${s1}.loadUrl(graphicUrl_dm1, configUrl_dm1);"$).Append(CRLF)
			Else
				sb.Append($"grap${s1}.loadUrl(graphicUrl_by1, configUrl_by1);"$).Append(CRLF)
			End If
			'
			sb.Append($"grap${s1}.on('ready', function () {"$).Append(CRLF)
			sb.Append($"    grap${s1}.view.zoomToFit(0,false);"$).Append(CRLF)
			sb.Append($"    grap${s1}.view.enableMouse(false,false);"$).Append(CRLF)
			' Set variable values
			If obj Is ABMDigitMeter1 Then
				sb.Append($"    grap${s1}.setValue('fronttext','${mp1.Get("fronttext")}');"$).Append(CRLF)
				sb.append($"    grap${s1}.setValue('backtext', '${mp1.Get("backtext")}');"$).Append(CRLF)
				sb.append($"    grap${s1}.setValue('title', '${mp1.Get("title")}');"$).Append(CRLF)
				sb.append($"    grap${s1}.setValue('unit', '${mp1.Get("unit")}');"$).Append(CRLF)
			Else
				sb.Append($"    grap${s1}.setValue('title1','${mp1.Get("title1")}');"$).Append(CRLF)
				sb.append($"    grap${s1}.setValue('title2', '${mp1.Get("title2")}');"$).Append(CRLF)
				sb.append($"    grap${s1}.setValue('value',false);"$).Append(CRLF)
			End If
			sb.Append("});").Append(CRLF)
		Next
		Dim s2 As String=sb.ToString
		InternalPage.ws.Eval(s2, Array As Object(ABMComp.ID))
	End If
End Sub

public Sub Refresh
	If ABMComp.IsInitialized Then
		ABMComp.Refresh
	End If
End Sub
 
' runs when a refresh is called
private Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	If data.Size>0 Then
		Dim n1 As Int
		Dim sb As StringBuilder
		sb.Initialize
		For n1=0 To data.Size-1
			Dim mp1 As Map=data.GetValueAt(n1)
			If mp1.get("obj") Is ABMDigitMeter1 Then
				Dim obj As ABMDigitMeter1 = mp1.get("obj")
				sb.Append(obj.Script)
			else if mp1.get("obj") Is ABMbinary1 Then
				Dim obj1 As ABMbinary1 = mp1.get("obj")
				sb.Append(obj1.Script)
			End If			
		Next
		If sb.ToString<>"" Then
			InternalPage.ws.Eval(sb.ToString, Array As Object(ABMComp.ID))
		End If
	End If
End Sub

Private Sub updateValue(InternalPage As ABMPage, internalID As String) As String
	Dim script As String = $""$
	Return script
End Sub
' do the stuff needed when the object is removed
private Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
 
End Sub
'
private Sub WritetoCSS(internalID As String,row As Int,col As Int,width As Int,height As Int,gap As Int) As String
	Dim wn As Int=(gap+clwidth)*col-gap
	Dim hn As Int=(gap+clheight)*row-gap
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"#${internalID} {"$).Append(CRLF)
	'sb.Append($"position: relative;"$).Append(CRLF)
	sb.Append($"width: ${wn}px;"$).Append(CRLF)
    sb.Append($"height: ${hn}px;"$).Append(CRLF)
	sb.Append("border: 1px;").Append(CRLF)
	sb.Append("position:relative;").Append(CRLF)
	'sb.Append("background-color: #00ff00;").Append(CRLF)
	'sb.Append("margin-left: 0px;").Append(CRLF)
	'sb.Append("margin-top: 0px;").Append(CRLF)
	sb.Append($"top:0px;"$).Append(CRLF)
	sb.Append($"left:0px;}"$).Append(CRLF)
	Dim n1 As Int
	Dim n2 As Int
	Dim ntop As Int=0
	Dim nleft As Int=0
	For n1=0 To row-1
		For n2=0 To col-1
			Dim s1 As String=internalID&jylab.ToHex(n1+1,2)&jylab.ToHex(n2+1,2)
			sb.Append(CRLF)
			sb.Append($"#${s1} {"$).Append(CRLF)
			sb.Append($"    position: absolute;"$).Append(CRLF)
			sb.Append($"    width: ${width}px;"$).Append(CRLF)
			sb.Append($"    height: ${height}px;"$).Append(CRLF)			
			'sb.Append("float:left;").Append(CRLF)
			sb.Append("margin: 0px;").Append(CRLF)
			sb.Append("padding:0px;").Append(CRLF)
			sb.Append($"top:${ntop}px;"$).Append(CRLF)
			sb.Append($"left:${nleft}px;}"$).Append(CRLF)
			nleft=nleft+width+gap
		Next
		ntop=ntop+height+gap
		nleft=0
	Next	
	' position: relative;
	' margin-left: 0px;
	' margin-top: 0px;
	Dim s3 As String="www\css\custom\"&internalID&".css"
	File.WriteString(File.DirApp,s3,sb.ToString)
	Return s1
End Sub
